
#include "config.h"

config *config_new()
{
	config *returnValue;

	returnValue = (config *) malloc(sizeof(config));
	memset(returnValue, 0, sizeof(config));

	returnValue->dataFilename = (char *) malloc(sizeof(char)*1024);
	returnValue->hierarchyFilename = (char *) malloc(sizeof(char)*1024);
	returnValue->ownershipFilename = (char *) malloc(sizeof(char)*1024);
	returnValue->closeFilename = (char *) malloc(sizeof(char)*1024);

	return returnValue;
}

config *config_readConfig(char *filename)
{
	config *returnValue;
	FILE *filePtr;

	filePtr = (FILE *) fopen(filename, "r");
	if (filePtr == NULL)
	{
		printf("File %s cannot be opened!\n", filename);
		exit(0);
	}

	returnValue = config_new();

	fscanf(filePtr, "%d\n", &(returnValue->noOfTuple));
	fscanf(filePtr, "%d\n", &(returnValue->noOfParty));
	fscanf(filePtr, "%d\n", &(returnValue->noOfValue));
	fscanf(filePtr, "%d\n", &(returnValue->noOfLowerSlot));
	fscanf(filePtr, "%s\n", returnValue->dataFilename);
	fscanf(filePtr, "%s\n", returnValue->hierarchyFilename);
	fscanf(filePtr, "%s\n", returnValue->ownershipFilename);
	fscanf(filePtr, "%s\n", returnValue->closeFilename);
	fscanf(filePtr, "%d\n", &(returnValue->noOfQueries));
	fscanf(filePtr, "%d\n", &(returnValue->noOfBatch));
	fscanf(filePtr, "%d\n", &(returnValue->seqLength));
	fscanf(filePtr, "%d\n", &(returnValue->alg));

	fclose(filePtr);

	return returnValue;
}

data *data_new(int noOfTuple)
{
	data *returnValue;

	returnValue = (data *) malloc(sizeof(data));
	memset(returnValue, 0, sizeof(data));

	returnValue->noOfTuple = noOfTuple;
	returnValue->tuple = (sequence *) malloc(sizeof(sequence)*noOfTuple);
	memset(returnValue->tuple, 0, sizeof(sequence)*noOfTuple);

	return returnValue;
}

data *data_readData(char *filename, int noOfTuple)
{
	data *returnValue;
	FILE *filePtr;

	sequence *aSequence;

	int noOfElt, aElt;

	int i, j;

	filePtr = (FILE *) fopen(filename, "r");
	if (filePtr == NULL)
	{
		printf("File %s cannot be opened!\n", filename);
		exit(0);
	}

	returnValue = data_new(noOfTuple);

	for (i = 0; i < noOfTuple; i++)
	{
		fscanf(filePtr, "%d ", &noOfElt);
		

		aSequence = &(returnValue->tuple[i]);
		aSequence->noOfElt = noOfElt;
		aSequence->elt = (int *) malloc(sizeof(int)*noOfElt);
		aSequence->level = (int *) malloc(sizeof(int)*noOfElt); 

		for (j = 0; j < noOfElt; j++)
		{
			fscanf(filePtr, "%d ", &aElt);

			aSequence->elt[j] = aElt;
		}
		fscanf(filePtr, "\n");
	}

	fclose(filePtr);

	return returnValue;
}

mySetSet *close_readClose(char *filename, int noOfElt)
{
	mySetSet *returnValue;

	FILE *filePtr;

	mySet *aSet;

	int noOfClose;
	int aElt;

	int i, j;

	filePtr = (FILE *) fopen(filename, "r");
	if (filePtr == NULL)
	{
		printf("File %s cannot be opened!\n", filename);
		exit(0);
	}

	returnValue = mySetSet_new_noOfElt(noOfElt);

	for (i = 0; i < noOfElt; i++)
	{
		fscanf(filePtr, "%d ", &noOfClose);

		aSet = mySet_new_noOfElt(noOfClose);
		
		returnValue->elt[i] = aSet;
		aSet->noOfElt = noOfClose;

		for (j = 0; j < noOfClose; j++)
		{
			fscanf(filePtr, "%d ", &aElt);
			aSet->elt[j] = aElt;
		}
	}

	fclose(filePtr);

	return returnValue;
}

int *owner_readOwner(char *filename, int noOfElt)
{
	FILE *filePtr;

	int *returnValue;

	int i;

	int aNo;

	filePtr = (FILE *) fopen(filename, "r");
	if (filePtr == NULL)
	{
		printf("File %s cannot be opened!\n", filename);
		exit(0);
	}

	returnValue = (int *) malloc(sizeof(int)*noOfElt);
	memset(returnValue, 0, sizeof(int)*noOfElt);

	for (i = 0; i < noOfElt; i++)
	{
		fscanf(filePtr, "%d", &aNo);

		returnValue[i] = aNo;
	}

	fclose(filePtr);

	return returnValue;
}



