
#ifndef CONFIG_H
#define CONFIG_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "set.h"
#include "sequence.h"

#define MAXSTR 1024

struct data_s
{
	int noOfTuple;
	sequence *tuple;
};

typedef struct data_s data;

struct config_s
{
	int noOfTuple;
	int noOfParty;
	int noOfValue;
	int noOfLowerSlot;
	char *dataFilename;
	char *hierarchyFilename;
	char *ownershipFilename;
	char *closeFilename;

	int noOfQueries;
	int noOfBatch;
	int seqLength;

	int alg;

	data *aData;
	// genHierarchy *aHierarchy;
};

typedef struct config_s config;

config *config_readConfig(char *filename);
data *data_readData(char *filename, int noOfTuple);
mySetSet *close_readClose(char *filename, int noOfElt);
int *owner_readOwner(char *filename, int noOfElt);

#endif
