
#include "service.h"

// assume ground
int service_isPotentialCompetitiveService(int elt1, int elt2, mySetSet *closeSetSet, int *ownerTable)
{
	int returnValue;

	mySet *closeSet1;
	mySet *closeSet2;

	closeSet1 = closeSetSet->elt[elt1];
	closeSet2 = closeSetSet->elt[elt2];

	if ((ownerTable[elt1] == ownerTable[elt2]) && (closeSet1->noOfElt != 0)  && (closeSet2->noOfElt != 0))
	{
		returnValue = 1;
	}
	else
	{
		returnValue = 0;
	}

	return returnValue;
}

void service_extractAllPotentialCompetitiveSerivceFromSequence(sequence *aSequence, upperHash *aUpperHash, mySetSet *closeSetSet, int *ownerTable)
{
	int i;

	int noOfElt;
	int *elt;

	int elt1, elt2;

	int isPotentialCompetitiveService;

	sequence *insertSequence;

	noOfElt = aSequence->noOfElt;
	elt = aSequence->elt;

	for (i = 0; i < noOfElt; i++)
	{
		elt1 = elt[i];

		//for (j = i+1; j < noOfElt; j++)
		if (i+1 < noOfElt)
		{
			elt2 = elt[i+1];

			isPotentialCompetitiveService = service_isPotentialCompetitiveService(elt1, elt2, closeSetSet, ownerTable);
			if (isPotentialCompetitiveService == 1)
			{
				insertSequence = sequence_new_noOfElt(2);
				insertSequence->elt[0] = elt1;
				insertSequence->elt[1] = elt2;

				upperHash_insert(aUpperHash, insertSequence);

				//printf("Inserting (%d, %d)...\n", elt1, elt2);
				//printf("    Size: %d\n", stat_calculateUpperHashSize(aUpperHash));
			}
		}
	}
}


void service_extractAllPotentialCompetitiveSerivceFromData(data *aData, upperHash *aUpperHash, mySetSet *closeSetSet, int *ownerTable)
{
	int noOfTuple;
	sequence *tuple;
	sequence *oneTuple;

	int i;

	noOfTuple = aData->noOfTuple;
	tuple = aData->tuple;

	for (i = 0; i < noOfTuple; i++)
	{
		oneTuple = &(tuple[i]);

		service_extractAllPotentialCompetitiveSerivceFromSequence(oneTuple, aUpperHash, closeSetSet, ownerTable);
	}
}

// assume; ground seq1
// and ground seq2
int service_isCompetitiveWithRespectToService(sequence *aSequence1, sequence *aSequence2, mySetSet *closeSetSet, int *ownerTable)
{
	int returnValue;

	int *elt1;
	int noOfElt1;
	int eltNo1;

	int *elt2;
	int noOfElt2;
	int eltNo2;

	mySet *aCloseSet1;

	int isExist;

	int i;

	elt1 = aSequence1->elt;
	noOfElt1 = aSequence1->noOfElt;

	elt2 = aSequence2->elt;
	noOfElt2 = aSequence2->noOfElt;

	if (noOfElt1 == noOfElt2)
	{
		returnValue = 1;
		for (i = 0; i < noOfElt1; i++)
		{
			eltNo1 = elt1[i];
			eltNo2 = elt2[i];

			if (ownerTable[eltNo1] == ownerTable[eltNo2])
			{
				returnValue = 0;
				break;
			}
			else
			{

				aCloseSet1 = closeSetSet->elt[eltNo1];

				isExist = mySet_isExist(aCloseSet1, eltNo2);
				if (isExist == 0)
				{
					returnValue = 0;
					break;
				}
			}
		}
	}
	else
	{
		returnValue = 0;
	}

	return returnValue;
}

// is Found
int service_findCompetitiveWithRespectToService(sequence *aSequence, lowerHash *aLowerHash, mySetSet *closeSetSet, int *ownerTable, upperHash *competitiveHash)
{
	int returnValue;

	int noOfSlot;
	sequenceSet **slot;
	sequenceSet *aSequenceSet;

	int noOfElt;
	sequence **elt;
	sequence *tempSequence;

	sequence *aSequence_new;
	sequence *tempSequence_new;

	int i, j;

	int isCompetitive;

	noOfSlot = aLowerHash->noOfSlot;
	slot = aLowerHash->slot;

	returnValue = 0;
	for (i = 0; i < noOfSlot; i++)
	{
		aSequenceSet = slot[i];

		noOfElt = aSequenceSet->noOfElt;
		elt = aSequenceSet->elt;

		for (j = 0; j < noOfElt; j++)
		{
			tempSequence = elt[j];

			isCompetitive = service_isCompetitiveWithRespectToService(aSequence, tempSequence, closeSetSet, ownerTable);
			if (isCompetitive == 1)
			{
				tempSequence->isCompetitive = 1;
				aSequence->isCompetitive = 1;

				aSequence_new = sequence_clone(aSequence);
				tempSequence_new = sequence_clone(tempSequence);

				returnValue = 1;

				upperHash_insert(competitiveHash, aSequence_new);
				upperHash_insert(competitiveHash, tempSequence_new);

				break;
			}
		}

		if (returnValue == 1)
		{
			break;
		}
	}

	return returnValue;	
}


// is Found
int service_findCompetitiveWithRespectToService_nonInsert(sequence *aSequence, lowerHash *aLowerHash, mySetSet *closeSetSet, int *ownerTable)
{
	int returnValue;

	int noOfSlot;
	sequenceSet **slot;
	sequenceSet *aSequenceSet;

	int noOfElt;
	sequence **elt;
	sequence *tempSequence;

	int i, j;

	int isCompetitive;

	noOfSlot = aLowerHash->noOfSlot;
	slot = aLowerHash->slot;

	returnValue = 0;
	for (i = 0; i < noOfSlot; i++)
	{
		aSequenceSet = slot[i];

		noOfElt = aSequenceSet->noOfElt;
		elt = aSequenceSet->elt;

		for (j = 0; j < noOfElt; j++)
		{
			tempSequence = elt[j];

			isCompetitive = service_isCompetitiveWithRespectToService(aSequence, tempSequence, closeSetSet, ownerTable);
			if (isCompetitive == 1)
			{

				returnValue = 1;

				break;
			}
		}

		if (returnValue == 1)
		{
			break;
		}
	}

	return returnValue;	
}

upperHash *service_findAllCompetitiveService(config *aConfig, upperHash *aUpperHash, mySetSet *closeSetSet, int *ownerTable)
{
	upperHash *returnValue;

	int upperNoOfSlot;
	lowerHash **upperSlot;

	lowerHash *aLowerHash;
	lowerHash *aLowerCompareHash;

	sequenceSet *aSequenceSet;

	sequence *aSequence;

	int i, j, k, l;

	int firstEltNo;

	mySet *aCloseSet;

	int lowerNoOfSlot;
	sequenceSet **lowerSlot;

	int closeNo;

	int isFound;

	returnValue = upperHash_new(aConfig->noOfValue, aConfig->noOfLowerSlot);

	upperNoOfSlot = aUpperHash->noOfSlot;
	upperSlot = aUpperHash->slot;

	for (i = 0; i < upperNoOfSlot; i++)
	{
		aLowerHash = upperSlot[i];

		lowerNoOfSlot = aLowerHash->noOfSlot;
		lowerSlot = aLowerHash->slot;

		for (j = 0; j < lowerNoOfSlot; j++)
		{
			aSequenceSet = lowerSlot[j];

			for (k = 0; k < aSequenceSet->noOfElt; k++)
			{
				aSequence = aSequenceSet->elt[k];

				if (aSequence->isCompetitive == 0)
				{
					// assume length > 0
					firstEltNo = aSequence->elt[0];

					aCloseSet = closeSetSet->elt[firstEltNo];

					for (l = 0; l < aCloseSet->noOfElt; l++)
					{
						closeNo = aCloseSet->elt[l];
						if (ownerTable[closeNo] != ownerTable[firstEltNo])
						{
							aLowerCompareHash = upperSlot[closeNo];

							isFound = service_findCompetitiveWithRespectToService(aSequence, aLowerCompareHash, closeSetSet, ownerTable, returnValue);
							if (isFound == 1)
							{
								break;
							}
						}
					}
				}
			}
		}
	}


	return returnValue;
}

// 
// -1: is not data independent correlated
int isCompetitive_DataIndependentCorrelation(int prev_isCompetitive, int olap_operation)
{
	int returnValue;

	returnValue = -1;
	if (prev_isCompetitive == 1)
	{
		if (olap_operation == DRILLDOWN)
		{
			returnValue = 1;
		}
		else if (olap_operation == DETAIL)
		{
			returnValue = 1;
		}
		else if (olap_operation == DEHEAD)
		{
			returnValue = 1;
		}
	}
	else
	{
		if (olap_operation == ROLLUP)
		{
			returnValue = 0;
		}
		else if (olap_operation == PREPEND)
		{
			returnValue = 0;
		}
		else if (olap_operation == APPEND)
		{
			returnValue = 0;
		}
	}
	
	return returnValue;
}


void generalizeDimension(int *value, int *level, generalizedLevelTable *genLevelTable)
{
	int i;

	int noOfPoss;


	noOfPoss = genLevelTable->noOfPoss;

	for (i = 0; i < noOfPoss; i++)
	{
		if (genLevelTable->gen[i].bottomValue == (*value))
		{
			// generalize
			(*value) = genLevelTable->gen[i].topValue;
			(*level) = genLevelTable->gen[i].topLevel;

			break;
		}
	}
}

mySetSet *findAllCompetitionAware(config *aConfig, generalizedDimTable *genHierarchy, mySetSet *aCloseSetSet)
{
	mySetSet *returnValue;

	mySet **elt;
	mySet *aSet;

	int level;

	mySet *aCloseSet;

	int i;

	int aValue;

	int new_value;
	int new_level;

	generalizedLevelTable *genLevelTable;

	returnValue = mySetSet_new_noOfElt(genHierarchy->noOfLevel);
	elt = returnValue->elt;
	for (i = 0; i < genHierarchy->noOfLevel; i++)
	{
		elt[i] = mySet_new();
	}

	for (i = 0; i < aConfig->noOfValue; i++)
	{
		aValue = i;

		aCloseSet = aCloseSetSet->elt[aValue];

		if (aCloseSet->noOfElt != 0)
		{
			level = 0;
			aSet = elt[level];

			mySet_insert(aSet, aValue);


			// generalized value
			while (level < genHierarchy->noOfLevel-1)
			{
				new_value = aValue;
				new_level = level;
				genLevelTable = &(genHierarchy->gen[new_level]);
				generalizeDimension(&new_value, &new_level, genLevelTable);

				aSet = elt[new_level];
				mySet_insert_nonRedundance(aSet, new_value);

				aValue = new_value;
				level = new_level;
			}
		}
	}

	return returnValue;
}

int isCompetitionAware(mySetSet *allCompetitionAwareNode, int level, int value)
{
	int returnValue;

	mySet *aSet;

	aSet = allCompetitionAwareNode->elt[level];

	returnValue = mySet_isExist(aSet, value);

	return returnValue;
}



mySet *getNodeSet(mySetSet **aSetSet, int level, int value)
{
	mySetSet *inSetSet;
	mySet *aSet;

	inSetSet = aSetSet[level];

	aSet = inSetSet->elt[value];

	return aSet;
}

mySetSet **reverseG_initialize(generalizedDimTable *genHierarchy)
{
	mySetSet **returnValue;

	generalizedLevelTable *genLevelTable;

	int noOfLevel;
	int noOfValue;

	int i, j;

	noOfLevel = genHierarchy->noOfLevel;

	returnValue = (mySetSet **) malloc(sizeof(mySetSet *)*noOfLevel);
	for (i = 0; i < noOfLevel; i++)
	{
		genLevelTable = &(genHierarchy->gen[i]);

		if (i < noOfLevel-1)
		{
			noOfValue = genLevelTable->noOfPoss;
		}
		else
		{
			noOfValue = 1;
		}

		returnValue[i] = mySetSet_new_noOfElt(noOfValue);

		for (j = 0; j < noOfValue; j++)
		{
			returnValue[i]->elt[j] = mySet_new();
		}
	}

	return returnValue;
}

mySetSet **generateReverseGForAllNode(generalizedDimTable *genHierarchy, int noOfValue)
{
	mySetSet **returnValue;

	generalizedLevelTable *genLevelTable;
	int i;

	int new_value, new_level;
	mySet *aSet;

	returnValue = reverseG_initialize(genHierarchy);

	for (i = 0; i < noOfValue; i++)
	{
		new_value = i;
		new_level = 0;

		//itself
		aSet = getNodeSet(returnValue, new_level, new_value);
		mySet_insert(aSet, i);

		// generalized value
		while (new_level < genHierarchy->noOfLevel-1)
		{
			genLevelTable = &(genHierarchy->gen[new_level]);
			generalizeDimension(&new_value, &new_level, genLevelTable);

			aSet = getNodeSet(returnValue, new_level, new_value);

			mySet_insert(aSet, i);
		}
	}
	
	return returnValue;
}

mySet *getReverseGForOneNode(mySetSet **allGroundSet, int level, int value)
{
	mySet *returnValue;

	mySetSet *aSetSet;

	aSetSet = allGroundSet[level];
	returnValue = aSetSet->elt[value];

	return returnValue;
}


sequence *performCompetitionAwareProjection(sequence *aSequence, mySetSet *allCompetitionAwareNode)
{
	sequence *returnValue;

	int *elt;
	int noOfElt;

	int noOfCompetitionAware;

	int i;

	int *isCA;

	int *level;
	int count;

	int one_level, one_value;


	elt = aSequence->elt;
	level = aSequence->level;
	noOfElt = aSequence->noOfElt;

	isCA = (int *) malloc(sizeof(int)*noOfElt);
	memset(isCA, 0, sizeof(int)*noOfElt);

	noOfCompetitionAware = 0;
	for (i = 0; i < noOfElt; i++)
	{
		one_level = level[i];
		one_value = elt[i];
		isCA[i] = isCompetitionAware(allCompetitionAwareNode, one_level, one_value);
		if (isCA[i] == 1)
		{
			noOfCompetitionAware++;
		}
	}

	returnValue = sequence_new_noOfElt(noOfCompetitionAware);

	count = 0;
	for (i = 0; i < noOfElt; i++)
	{
		one_level = level[i];
		one_value = elt[i];
		isCA[i] = isCompetitionAware(allCompetitionAwareNode, one_level, one_value);
		if (isCA[i] == 1)
		{
			
			returnValue->level[count] = level[i];
			returnValue->elt[count] = elt[i];
			count++;
		}
	}

	free(isCA);

	return returnValue;
}

sequence *sequence_service_new(int elt1, int elt2)
{
	sequence *returnValue;

	returnValue = sequence_new_noOfElt(2);

	returnValue->elt[0] = elt1;
	returnValue->elt[1] = elt2;

	return returnValue;
}

upperHash *generatePCSSFromSummary(sequence *aSequence, config *aConfig, mySetSet **allGroundSet, upperHash *competitiveServiceSet, mySetSet *allCompetitionAwareNode)
{
	upperHash *returnValue;
	sequence *proj_sequence;

	int *proj_elt;
	int *proj_level;
	int proj_noOfElt;

	int i, k, l;

	int firstElt, secondElt;
	int firstLevel, secondLevel;

	lowerHash *competitive_lowerHash;

	mySet *firstGroundSet;
	mySet *secondGroundSet;

	int *firstGroundSet_elt;
	int *secondGroundSet_elt;

	int oneElt, twoElt;

	sequence *tempSequence;

	int isExist;

	returnValue = upperHash_new(aConfig->noOfValue, aConfig->noOfLowerSlot);

	proj_sequence = performCompetitionAwareProjection(aSequence, allCompetitionAwareNode);

	proj_elt = proj_sequence->elt;
	proj_level = proj_sequence->level;
	proj_noOfElt = proj_sequence->noOfElt;

	for (i = 0; i < proj_noOfElt; i++)
	{
		firstElt = proj_elt[i];
		firstLevel = proj_level[i];

		firstGroundSet = getReverseGForOneNode(allGroundSet, firstLevel, firstElt);

		firstGroundSet_elt = firstGroundSet->elt;
		for (k = 0; k < firstGroundSet->noOfElt; k++)
		{
			oneElt = firstGroundSet_elt[k];
			competitive_lowerHash = competitiveServiceSet->slot[oneElt];

			if (competitive_lowerHash->noOfSlot > 0)
			{
				//lowerHash_slotNo(, lower
				//competitive_lowerHash->slot[l];
				//*** to be changed
				//for (j = i+1; j < proj_noOfElt; j++)
				//for (j = i+1; j <= i+1; j++)
				if (i+1 < proj_noOfElt)
				{
					secondElt = proj_elt[i+1];
					secondLevel = proj_level[i+1];

					secondGroundSet = getReverseGForOneNode(allGroundSet, secondLevel, secondElt);

					secondGroundSet_elt = secondGroundSet->elt;
					for (l = 0; l < secondGroundSet->noOfElt; l++)
					{
						twoElt = secondGroundSet_elt[l];

						tempSequence = sequence_service_new(oneElt, twoElt);

						isExist = lowerHash_isExist(competitive_lowerHash, tempSequence);
						//slotNo = lowerHash_slotNo(tempSequence, competitive_lowerHash->noOfSlot);
						//aSequenceSet = competitive_lowerHash->slot[slotNo];

						if (isExist == 1)
						{
							// insert
							upperHash_insert(returnValue, tempSequence);
						}
						else
						{
							sequence_free(tempSequence);
						}
					}

					//mySet_free(secondGroundSet);
				}
			}
		}

		//mySet_free(firstGroundSet);
	}

	return returnValue;
}




int determineWhetherQueryCompetitiveFreeFromPCSS(config *aConfig, upperHash *competitiveHash, upperHash *PCSS, mySetSet *closeSetSet, int *ownerTable)
{
	int returnValue;


	int isEmpty;

	isEmpty = upperHash_isEmpty(PCSS);
	if (isEmpty == 1)
	{
		returnValue = 1;
	}
	else
	{
		returnValue = 0;
	}


	return returnValue;
}

// newValue and newLevel are the prpended elt
upperHash *generatePCSSFromRelatedPCSS_prepend(sequence **newSequence, int newValue, int newLevel, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;

	int proceed_value, proceed_level;

	mySet *setNew;
	mySet *setProceed;

	sequence *aSequence;

	int i, j;

	int isCA, isCA_proceed;

	int new_ground_value;
	int proceed_ground_value;

	int isExist;

	(*newSequence) = sequence_new_noOfElt(prevSequence->noOfElt+1);
	(*newSequence)->elt[0] = newValue;
	(*newSequence)->level[0] = newLevel;
	if (prevSequence->noOfElt > 0)
	{
		memcpy(&((*newSequence)->elt[1]), prevSequence->elt, sizeof(int)*prevSequence->noOfElt);
		memcpy(&((*newSequence)->level[1]), prevSequence->level, sizeof(int)*prevSequence->noOfElt);
	}

	returnValue = upperHash_clone(prevPCSS);

	isCA = isCompetitionAware(allCompetitionAwareNode, newLevel, newValue);
	if (isCA == 0)
	{
		// do nothing
	}
	else
	{
		// need to add more services
		if (prevSequence->noOfElt > 0)
		{
			proceed_value = prevSequence->elt[0];
			proceed_level = prevSequence->level[0];

			isCA_proceed = isCompetitionAware(allCompetitionAwareNode, proceed_level, proceed_value);

			if (isCA_proceed == 1)
			{
				// generate all possible 

				setNew = getReverseGForOneNode(allGroundSet, newLevel, newValue);
				for (i = 0; i < setNew->noOfElt; i++)
				{
					new_ground_value = setNew->elt[i];
					
					setProceed = getReverseGForOneNode(allGroundSet, proceed_level, proceed_value);
					for (j = 0; j < setProceed->noOfElt; j++)
					{
						proceed_ground_value = setProceed->elt[j];
						aSequence = sequence_new_noOfElt(2);
						aSequence->elt[0] = new_ground_value;
						aSequence->elt[1] = proceed_ground_value;

						
						isExist = upperHash_isExist(competitiveServiceSet, aSequence);
						if (isExist == 1)
						{
							upperHash_insert(returnValue, aSequence);
						}
						else
						{
							sequence_free(aSequence);
						}
					}
				}
				
			}
			else
			{
				// do nothing
			}
		}
		else
		{

			// do nothing
		}
	}

	return returnValue;
}



// newValue and newLevel are the appended elt
upperHash *generatePCSSFromRelatedPCSS_append(sequence **newSequence, int newValue, int newLevel, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;

	int prev_value, prev_level;

	mySet *setNew;
	mySet *setProceed;

	sequence *aSequence;

	int i, j;

	int isCA, isCA_prev;

	int new_ground_value;
	int prev_ground_value;

	int isExist;

	(*newSequence) = sequence_new_noOfElt(prevSequence->noOfElt+1);
	(*newSequence)->elt[prevSequence->noOfElt] = newValue;
	(*newSequence)->level[prevSequence->noOfElt] = newLevel;
	if (prevSequence->noOfElt > 0)
	{
		memcpy((*newSequence)->elt, prevSequence->elt, sizeof(int)*prevSequence->noOfElt);
		memcpy((*newSequence)->level, prevSequence->level, sizeof(int)*prevSequence->noOfElt);
	}

	returnValue = upperHash_clone(prevPCSS);

	isCA = isCompetitionAware(allCompetitionAwareNode, newLevel, newValue);
	if (isCA == 0)
	{
		// do nothing
	}
	else
	{
		// need to add more services
		if (prevSequence->noOfElt > 0)
		{
			prev_value = prevSequence->elt[prevSequence->noOfElt-1];
			prev_level = prevSequence->level[prevSequence->noOfElt-1];

			isCA_prev = isCompetitionAware(allCompetitionAwareNode, prev_level, prev_value);

			if (isCA_prev == 1)
			{
				// generate all possible 

				setNew = getReverseGForOneNode(allGroundSet, newLevel, newValue);
				for (i = 0; i < setNew->noOfElt; i++)
				{
					new_ground_value = setNew->elt[i];
					
					setProceed = getReverseGForOneNode(allGroundSet, prev_level, prev_value);
					for (j = 0; j < setProceed->noOfElt; j++)
					{
						prev_ground_value = setProceed->elt[j];

						aSequence = sequence_new_noOfElt(2);
						aSequence->elt[0] = prev_ground_value;
						aSequence->elt[1] = new_ground_value;

						isExist = upperHash_isExist(competitiveServiceSet, aSequence);
						if (isExist == 1)
						{
							upperHash_insert(returnValue, aSequence);
						}
						else
						{
							sequence_free(aSequence);
						}
					}
				}
				
			}
			else
			{
				// do nothing
			}
		}
		else
		{

			// do nothing
		}
	}

	return returnValue;
}



// rollupIndex
upperHash *generatePCSSFromRelatedPCSS_rollup(generalizedDimTable *genHierarchy, sequence **newSequence, int rollupIndex, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;

	int prev_value, prev_level;
	int next_value, next_level;

	int orgValue, orgLevel;
	int genValue, genLevel;

	mySet *setNew;
	mySet *setProceed;

	generalizedLevelTable *genLevelTable;

	sequence *aSequence;

	int gen_ground_value;
	int next_ground_value;
	int prev_ground_value;


	int i, j;

	int isExist;

	int isCA, isCA_prev, isCA_next;

	(*newSequence) = sequence_new_noOfElt(prevSequence->noOfElt);
	if (prevSequence->noOfElt > 0)
	{
		memcpy((*newSequence)->elt, prevSequence->elt, sizeof(int)*prevSequence->noOfElt);
		memcpy((*newSequence)->level, prevSequence->level, sizeof(int)*prevSequence->noOfElt);
	}

	orgValue = prevSequence->elt[rollupIndex];
	orgLevel = prevSequence->level[rollupIndex];

	genValue = orgValue;
	genLevel = orgLevel;
	
	genLevelTable = &(genHierarchy->gen[genLevel]);
	generalizeDimension(&genValue, &genLevel, genLevelTable);

	(*newSequence)->elt[rollupIndex] = genValue;
	(*newSequence)->level[rollupIndex] = genLevel; 

	// printing
	//printf("Inside relatedPCSS: printing...\n");
	//upperHash_print(prevPCSS);
	//printf("Inside relatedPCSS: finish printing...\n");


	returnValue = upperHash_clone(prevPCSS);

	isCA = isCompetitionAware(allCompetitionAwareNode, genLevel, genValue);
	if (isCA == 0)
	{
		// do nothing
	}
	else
	{
		// need to add more services
		if (prevSequence->noOfElt > 0)
		{
			//
			if (rollupIndex-1 >= 0)
			{
				prev_value = prevSequence->elt[rollupIndex-1];
				prev_level = prevSequence->level[rollupIndex-1];

				isCA_prev = isCompetitionAware(allCompetitionAwareNode, prev_level, prev_value);

				if (isCA_prev == 1)
				{
					// generate all possible 

					setNew = getReverseGForOneNode(allGroundSet, genLevel, genValue);
					for (i = 0; i < setNew->noOfElt; i++)
					{
						gen_ground_value = setNew->elt[i];
						
						setProceed = getReverseGForOneNode(allGroundSet, prev_level, prev_value);
						for (j = 0; j < setProceed->noOfElt; j++)
						{
							prev_ground_value = setProceed->elt[j];
							aSequence = sequence_new_noOfElt(2);
							aSequence->elt[0] = prev_ground_value;
							aSequence->elt[1] = gen_ground_value;

							isExist = upperHash_isExist(competitiveServiceSet, aSequence);
							if (isExist == 1)
							{
								upperHash_insert(returnValue, aSequence);
							}
							else
							{
								sequence_free(aSequence);
							}
						}
					}
					
				}
				else
				{
					// do nothing
				}
			}

			//
			if (rollupIndex+1 <= prevSequence->noOfElt-1)
			{
				next_value = prevSequence->elt[rollupIndex+1];
				next_level = prevSequence->level[rollupIndex+1];

				isCA_next = isCompetitionAware(allCompetitionAwareNode, next_level, next_value);

				if (isCA_next == 1)
				{
					// generate all possible 

					setNew = getReverseGForOneNode(allGroundSet, genLevel, genValue);
					for (i = 0; i < setNew->noOfElt; i++)
					{
						gen_ground_value = setNew->elt[i];
						
						setProceed = getReverseGForOneNode(allGroundSet, next_level, next_value);
						for (j = 0; j < setProceed->noOfElt; j++)
						{
							next_ground_value = setProceed->elt[j];
							aSequence = sequence_new_noOfElt(2);
							aSequence->elt[0] = gen_ground_value;
							aSequence->elt[1] = next_ground_value;
							isExist = upperHash_isExist(competitiveServiceSet, aSequence);
							if (isExist == 1)
							{
								upperHash_insert(returnValue, aSequence);
							}
							else
							{
								sequence_free(aSequence);
							}
						}
					}
					
				}
				else
				{
					// do nothing
				}
			}
		}
		else
		{

			// do nothing
		}
	}

	return returnValue;
}

int isAncestorOrDescendant(int level1, int value1, int level2, int value2, generalizedDimTable *genHierarchy)
{
	int returnValue;

	int tempValue;
	int tempLevel;

	generalizedLevelTable *genLevelTable;

	if (level1 == level2)
	{
		if (value1 == value2)
		{
			returnValue = 1;
		}
		else
		{
			returnValue = 0;
		}
	}
	else if (level1 < level2)
	{
		tempValue = value1;
		tempLevel = level1;

		while (tempLevel < level2)
		{
			genLevelTable = &(genHierarchy->gen[tempLevel]);
			generalizeDimension(&tempValue, &tempLevel, genLevelTable);
		}

		if (value2 == tempValue)
		{
			returnValue = 1;
		}
		else
		{
			returnValue = 0;
		}
	}
	else
	{
		tempValue = value2;
		tempLevel = level2;

		while (tempLevel < level1)
		{
			genLevelTable = &(genHierarchy->gen[tempLevel]);
			generalizeDimension(&tempValue, &tempLevel, genLevelTable);
		}

		if (value1 == tempValue)
		{
			returnValue = 1;
		}
		else
		{
			returnValue = 0;
		}
	}

	return returnValue;
}

int isExist_parentOrDescendant(int level, int value, sequence *aSequence, int startIndex, int endIndex, generalizedDimTable *genHierarchy)
{
	int returnValue;
	int i;

	int oneValue, oneLevel;

	int isExist;

	returnValue = 0;
	for (i = startIndex; i <= endIndex ; i++)
	{
		oneValue = aSequence->elt[i];
		oneLevel = aSequence->level[i];

		isExist = isAncestorOrDescendant(level, value, oneLevel, oneValue, genHierarchy);
		if (isExist == 1)
		{
			returnValue = 1;
			break;
		}
	}

	return returnValue;
}

upperHash *generatePCSSFromRelatedPCSS_detail(generalizedDimTable *genHierarchy, sequence **newSequence, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, config *aConfig, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;

	int prev_value, prev_level;

	mySet *setNew;
	mySet *setProceed;


	int upper_noOfSlot;
	int lower_noOfSlot;

	int detail_level, detail_value;
	int detail_ground_value;

	int prev_ground_value;


	int i, j;

	int isExist;

	int isCA, isCA_prev;

	if (prevSequence->noOfElt <= 1)
	{
		upper_noOfSlot = prevPCSS->noOfSlot;
		lower_noOfSlot = prevPCSS->slot[0]->noOfSlot;
		returnValue = upperHash_new(upper_noOfSlot, lower_noOfSlot);

		(*newSequence) = sequence_new();
	}
	else
	{

		(*newSequence) = sequence_new_noOfElt(prevSequence->noOfElt-1);
		if (prevSequence->noOfElt > 0)
		{
			memcpy((*newSequence)->elt, prevSequence->elt, sizeof(int)*(prevSequence->noOfElt-1));
			memcpy((*newSequence)->level, prevSequence->level, sizeof(int)*(prevSequence->noOfElt-1));
		}

		

		/// 
		detail_level = prevSequence->level[prevSequence->noOfElt-1];
		detail_value = prevSequence->elt[prevSequence->noOfElt-1];

		


		isCA = isCompetitionAware(allCompetitionAwareNode, detail_level, detail_value);
		if (isCA == 0)
		{
			// do nothing

			returnValue = upperHash_clone(prevPCSS);
		}
		else
		{

			isExist = isExist_parentOrDescendant(detail_level, detail_value, prevSequence, 0, prevSequence->noOfElt-2, genHierarchy);

			if (isExist == 1)
			{
				// generate from scratch
				returnValue = generatePCSSFromSummary((*newSequence), aConfig, allGroundSet, competitiveServiceSet, allCompetitionAwareNode);
			}
			else
			{
				returnValue = upperHash_clone(prevPCSS);

				prev_level = prevSequence->level[prevSequence->noOfElt-2];
				prev_value = prevSequence->elt[prevSequence->noOfElt-2];

				isCA_prev = isCompetitionAware(allCompetitionAwareNode, prev_level, prev_value);

				if (isCA_prev == 1)
				{
					// generate all possible 
					
					setNew = getReverseGForOneNode(allGroundSet, detail_level, detail_value);
					for (i = 0; i < setNew->noOfElt; i++)
					{
						detail_ground_value = setNew->elt[i];
						setProceed = getReverseGForOneNode(allGroundSet, prev_level, prev_value);
						for (j = 0; j < setProceed->noOfElt; j++)
						{
							prev_ground_value = setProceed->elt[j];

							upperHash_removeService(returnValue, prev_ground_value, detail_ground_value);
						}
					}
					
				}
				else
				{
					// do nothing
				}
			}



		}
	}

	return returnValue;
}


upperHash *generatePCSSFromRelatedPCSS_dehead(generalizedDimTable *genHierarchy, sequence **newSequence, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, config *aConfig, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;

	int next_value, next_level;

	mySet *setNew;
	mySet *setProceed;


	int upper_noOfSlot;
	int lower_noOfSlot;

	int dehead_level, dehead_value;
	int dehead_ground_value;

	int next_ground_value;


	int i, j;

	int isExist;

	int isCA, isCA_next;

	if (prevSequence->noOfElt <= 1)
	{
		upper_noOfSlot = prevPCSS->noOfSlot;
		lower_noOfSlot = prevPCSS->slot[0]->noOfSlot;
		returnValue = upperHash_new(upper_noOfSlot, lower_noOfSlot);

		(*newSequence) = sequence_new();
	}
	else
	{

		(*newSequence) = sequence_new_noOfElt(prevSequence->noOfElt-1);
		if (prevSequence->noOfElt > 0)
		{
			memcpy((*newSequence)->elt, &(prevSequence->elt[1]), sizeof(int)*(prevSequence->noOfElt-1));
			memcpy((*newSequence)->level, &(prevSequence->level[1]), sizeof(int)*(prevSequence->noOfElt-1));
		}


		/// 
		dehead_level = prevSequence->level[0];
		dehead_value = prevSequence->elt[0];

		


		isCA = isCompetitionAware(allCompetitionAwareNode, dehead_level, dehead_value);
		if (isCA == 0)
		{
			// do nothing

			
			returnValue = upperHash_clone(prevPCSS);
		}
		else
		{

			isExist = isExist_parentOrDescendant(dehead_level, dehead_value, prevSequence, 1, prevSequence->noOfElt-1, genHierarchy);

			if (isExist == 1)
			{
				// generate from scratch
				returnValue = generatePCSSFromSummary((*newSequence), aConfig, allGroundSet, competitiveServiceSet, allCompetitionAwareNode);
			}
			else
			{
				returnValue = upperHash_clone(prevPCSS);

				next_level = prevSequence->level[1];
				next_value = prevSequence->elt[1];

				isCA_next = isCompetitionAware(allCompetitionAwareNode, next_level, next_value);

				if (isCA_next == 1)
				{
					// generate all possible 
					
					setNew = getReverseGForOneNode(allGroundSet, dehead_level, dehead_value);
					for (i = 0; i < setNew->noOfElt; i++)
					{
						dehead_ground_value = setNew->elt[i];
						setProceed = getReverseGForOneNode(allGroundSet, next_level, next_value);
						for (j = 0; j < setProceed->noOfElt; j++)
						{
							next_ground_value = setProceed->elt[j];

							upperHash_removeService(returnValue, dehead_ground_value, next_ground_value);
						}
					}
					
				}
				else
				{
					// do nothing
				}
			}



		}
	}

	return returnValue;
}

void getFirstChild(int level, int value, int *childLevel, int *childValue, int noOfValue, generalizedDimTable *genHierarchy)
{
	int i;

	int tempValue, tempLevel;
	int prevTempValue, prevTempLevel;

	generalizedLevelTable *genLevelTable;

	if (level == 0)
	{
		(*childLevel) = level;
		(*childValue) = value;
	}
	else
	{
		for (i = 0; i < noOfValue; i++)
		{
			tempValue = i;
			tempLevel = 0;

			while (tempLevel < level)
			{
				prevTempValue = tempValue;
				prevTempLevel = tempLevel;

				genLevelTable = &(genHierarchy->gen[tempLevel]);
				generalizeDimension(&tempValue, &tempLevel, genLevelTable);

				if ((tempLevel == level) && (tempValue == value))
				{
					(*childLevel) = prevTempLevel;
					(*childValue) = prevTempValue;
					break;
				}
			}
		}
	}
}

mySet *getRedundant_drillDown(int level, int value, int *childLevel, int *childValue, generalizedDimTable *genHierarchy, mySetSet **allGroundSet, int noOfValue)
{
	mySet *returnValue;

	mySet *parentSet;
	mySet *childSet;

	getFirstChild(level, value, childLevel, childValue, noOfValue, genHierarchy);

	if ((value == (*childValue)) && (level == (*childLevel)))
	{
		returnValue = mySet_new();
	}
	else
	{

		parentSet = getReverseGForOneNode(allGroundSet, level, value);

		childSet = getReverseGForOneNode(allGroundSet, (*childLevel), (*childValue));

		returnValue = mySet_minus(parentSet, childSet);
	}

	return returnValue;
}


upperHash *generatePCSSFromRelatedPCSS_drillDown(generalizedDimTable *genHierarchy, int drillDownIndex, sequence **newSequence, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, config *aConfig, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;

	int next_value, next_level;

	mySet *setNew;
	mySet *setProceed;

	int drillDown_ground_value;

	int next_ground_value;


	int i, j;

	int isExist, isExist2;

	int isCA, isCA_next;

	int noOfValue;

	int parentLevel, parentValue;
	int childLevel, childValue;


		(*newSequence) = sequence_new_noOfElt(prevSequence->noOfElt);
		if (prevSequence->noOfElt > 0)
		{
			memcpy((*newSequence)->elt, prevSequence->elt, sizeof(int)*(prevSequence->noOfElt));
			memcpy((*newSequence)->level, prevSequence->level, sizeof(int)*(prevSequence->noOfElt));
		}
	
		noOfValue = aConfig->noOfValue;
		parentLevel = prevSequence->level[drillDownIndex];
		parentValue = prevSequence->elt[drillDownIndex];
		getFirstChild(parentLevel, parentValue, &childLevel, &childValue, noOfValue, genHierarchy);

		(*newSequence)->elt[drillDownIndex] = childValue;
		(*newSequence)->level[drillDownIndex] = childLevel;

		



		isCA = isCompetitionAware(allCompetitionAwareNode, parentLevel, parentValue);
		if (isCA == 0)
		{
			// do nothing
			returnValue = upperHash_clone(prevPCSS);
		}
		else
		{

			if (drillDownIndex-1 >= 0)
			{
				isExist = isExist_parentOrDescendant(parentLevel, parentValue, prevSequence, 0, drillDownIndex-1, genHierarchy);
			}
			else
			{
				isExist = 0;
			}

			

			if (drillDownIndex+1 <= prevSequence->noOfElt-1)
			{
				isExist2 = isExist_parentOrDescendant(parentLevel, parentValue, prevSequence, drillDownIndex+1, prevSequence->noOfElt-1, genHierarchy);
			}
			else
			{
				isExist2 = 0;
			}

			if ((isExist == 1) || (isExist2 == 1))
			{
				// generate from scratch
				returnValue = generatePCSSFromSummary((*newSequence), aConfig, allGroundSet, competitiveServiceSet, allCompetitionAwareNode);
			}
			else
			{
				returnValue = upperHash_clone(prevPCSS);

				if (drillDownIndex-1 >= 0)
				{
					next_level = prevSequence->level[drillDownIndex-1];
					next_value = prevSequence->elt[drillDownIndex-1];

					isCA_next = isCompetitionAware(allCompetitionAwareNode, next_level, next_value);

					if (isCA_next == 1)
					{
						// generate all possible 
						
						//setNew = getReverseGForOneNode(allGroundSet, dehead_level, dehead_value);
						setNew = getRedundant_drillDown(parentLevel, parentValue, &childLevel, &childValue, genHierarchy, allGroundSet, noOfValue);
						for (i = 0; i < setNew->noOfElt; i++)
						{
							drillDown_ground_value = setNew->elt[i];
							setProceed = getReverseGForOneNode(allGroundSet, next_level, next_value);
							for (j = 0; j < setProceed->noOfElt; j++)
							{
								next_ground_value = setProceed->elt[j];

								upperHash_removeService(returnValue, next_ground_value, drillDown_ground_value);
							}
						}

						mySet_free(setNew);
						
					}
					else
					{
						// do nothing
					}
				}

				//
				if (drillDownIndex+1 <= prevSequence->noOfElt-1)
				{
					next_level = prevSequence->level[drillDownIndex+1];
					next_value = prevSequence->elt[drillDownIndex+1];

					isCA_next = isCompetitionAware(allCompetitionAwareNode, next_level, next_value);

					if (isCA_next == 1)
					{
						// generate all possible 
						
						//setNew = getReverseGForOneNode(allGroundSet, dehead_level, dehead_value);
						setNew = getRedundant_drillDown(parentLevel, parentValue, &childLevel, &childValue, genHierarchy, allGroundSet, noOfValue);
						for (i = 0; i < setNew->noOfElt; i++)
						{
							drillDown_ground_value = setNew->elt[i];
							setProceed = getReverseGForOneNode(allGroundSet, next_level, next_value);
							for (j = 0; j < setProceed->noOfElt; j++)
							{
								next_ground_value = setProceed->elt[j];

								upperHash_removeService(returnValue, drillDown_ground_value, next_ground_value);
							}
						}

						mySet_free(setNew);
						
					}
					else
					{
						// do nothing
					}
				}
			}



		}


	return returnValue;
}

upperHash *performAppend(generalizedDimTable *genHierarchy, sequence **newSequence, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;
	int newValue;
	int newLevel;

	int noOfValue;
	int noOfLevel;

	noOfLevel = genHierarchy->noOfLevel;
	//newLevel = rand()%noOfLevel;

	newLevel = 0;

	noOfValue = genHierarchy->gen[newLevel].noOfPoss;
	if (noOfValue == 0)
	{
		// for the root
		noOfValue = 1;
	}

	newValue = rand()%noOfValue;
	
	returnValue = generatePCSSFromRelatedPCSS_append(newSequence, newValue, newLevel, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, competitiveServiceSet);

	return returnValue;
}

upperHash *performPrepend(generalizedDimTable *genHierarchy, sequence **newSequence, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;
	int newValue;
	int newLevel;

	int noOfValue;
	int noOfLevel;

	noOfLevel = genHierarchy->noOfLevel;
	//newLevel = rand()%noOfLevel;
	newLevel = 0;

	noOfValue = genHierarchy->gen[newLevel].noOfPoss;
	if (noOfValue == 0)
	{
		// for root
		noOfValue = 1;
	}

	newValue = rand()%noOfValue;
	
	returnValue = generatePCSSFromRelatedPCSS_prepend(newSequence, newValue, newLevel, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, competitiveServiceSet);

	return returnValue;
}

upperHash *performRollup(generalizedDimTable *genHierarchy, sequence **newSequence, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;

	int rollupIndex;

	if (prevSequence->noOfElt > 0)
	{
		rollupIndex = rand()%prevSequence->noOfElt;
		
		returnValue = generatePCSSFromRelatedPCSS_rollup(genHierarchy, newSequence, rollupIndex, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, competitiveServiceSet);
	}
	else
	{
		(*newSequence) = sequence_clone(prevSequence);
		returnValue = upperHash_clone(prevPCSS);
	}

	return returnValue;
}

upperHash *performDrillDown(generalizedDimTable *genHierarchy, sequence **newSequence, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, config *aConfig, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;

	int drillDownIndex;

	if (prevSequence->noOfElt > 0)
	{
		drillDownIndex = rand()%prevSequence->noOfElt;
		
		returnValue = generatePCSSFromRelatedPCSS_drillDown(genHierarchy, drillDownIndex, newSequence, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, aConfig, competitiveServiceSet);
	}
	else
	{
		(*newSequence) = sequence_clone(prevSequence);
		returnValue = upperHash_clone(prevPCSS);
	}

	return returnValue;
}

upperHash *performDetail(generalizedDimTable *genHierarchy, sequence **newSequence, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, config *aConfig, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;

	returnValue = generatePCSSFromRelatedPCSS_detail(genHierarchy, newSequence, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, aConfig, competitiveServiceSet);

	return returnValue;
}

upperHash *performDehead(generalizedDimTable *genHierarchy, sequence **newSequence, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, config *aConfig, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;

	returnValue = generatePCSSFromRelatedPCSS_dehead(genHierarchy, newSequence, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, aConfig, competitiveServiceSet);

	return returnValue;
}

upperHash *generatePCSSFromRelatedPCSS(int operationNo, generalizedDimTable *genHierarchy, config *aConfig, sequence **newSequence, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, upperHash *competitiveServiceSet)
{
	upperHash *returnValue;

	switch(operationNo)
	{
	case DRILLDOWN:
		returnValue = performDrillDown(genHierarchy, newSequence, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, aConfig, competitiveServiceSet);
		break;
	case ROLLUP:
		returnValue = performRollup(genHierarchy, newSequence, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, competitiveServiceSet);
		break;
	case PREPEND:
		returnValue = performPrepend(genHierarchy, newSequence, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, competitiveServiceSet);
		break;
	case APPEND:
		returnValue = performAppend(genHierarchy, newSequence, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, competitiveServiceSet);
		break;
	case DETAIL:
		returnValue = performDetail(genHierarchy, newSequence, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, aConfig, competitiveServiceSet);
		break;
	case DEHEAD:
		returnValue = performDehead(genHierarchy, newSequence, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, aConfig, competitiveServiceSet);
		break;
	default:
		returnValue = NULL;
		break;
	}

	return returnValue;
}


int determineWhetherQueryCompetitionFree(int prev_isCompetitive, int olap_operation, generalizedDimTable *genHierarchy, config *aConfig, sequence **newSequence, upperHash **newPCSS, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, upperHash *competitiveServiceSet, mySetSet *closeSetSet, int *ownerTable)
{
	int returnValue;

	upperHash *new_PCSS;

//printf("===== 1\n");
	returnValue = isCompetitive_DataIndependentCorrelation(prev_isCompetitive, olap_operation);
//printf("===== 2 (olap_operation = %d)\n", olap_operation);
	new_PCSS = generatePCSSFromRelatedPCSS(olap_operation, genHierarchy, aConfig, newSequence, prevSequence, prevPCSS, allCompetitionAwareNode, allGroundSet, competitiveServiceSet);
//printf("===== 3\n");
	(*newPCSS) = new_PCSS;
	if (returnValue == -1)
	{
//printf("===== 4\n");
		returnValue = determineWhetherQueryCompetitiveFreeFromPCSS(aConfig, competitiveServiceSet, new_PCSS, closeSetSet, ownerTable);
//printf("===== 5\n");
	}
//printf("===== 6\n");
	return returnValue;
}

sequence *generateRandomSequence(int seqLen, generalizedDimTable *genHierarchy)
{
	sequence *returnValue;

	int i;

	int noOfLevel;
	int noOfValue;

	int randLevel;

	noOfLevel = genHierarchy->noOfLevel;

	returnValue = sequence_new_noOfElt(seqLen);
	for (i = 0; i < seqLen; i++)
	{
		randLevel = rand()%noOfLevel;
		//returnValue->level[i] = randLevel;
		returnValue->level[i] = 0;

		noOfValue = genHierarchy->gen[randLevel].noOfPoss;
		if (noOfValue == 0)
		{
			noOfValue = 1;
		}
		returnValue->elt[i] = rand()%noOfValue;
	}

	return returnValue;
}

void printAllGroundSet(mySetSet **allGroundSet, int noOfLevel)
{
	int i, j;

	mySet *aSet;

	int noOfElt;
	mySet **elt;

	for (i = 0; i < noOfLevel; i++)
	{
		printf("Level %d\n", i);
		printf("---------\n");
		noOfElt = allGroundSet[i]->noOfElt;
		elt = allGroundSet[i]->elt;

		
		for (j = 0; j < noOfElt; j++)
		{
			printf("   Entry %d: ", j);
			aSet = elt[j];

			mySet_print(aSet);
			printf("\n");
		}
	}

}

