
#include "statistics.h"

statistics *stat_new()
{
	statistics *returnValue;

	returnValue = (statistics *) malloc(sizeof(statistics));
	memset(returnValue, 0, sizeof(statistics));

	return returnValue;
}

int stat_calculateLowerHashSize(lowerHash *aLowerHash)
{
	int returnValue;

	int noOfSlot;

	sequenceSet *aSeqSet;

	int noOfElt;
	sequence **elt;

	int i, j;

	returnValue = 0; 

	noOfSlot = aLowerHash->noOfSlot;
	for (i = 0; i < noOfSlot; i++)
	{
		aSeqSet = aLowerHash->slot[i];

		noOfElt = aSeqSet->noOfElt;
		elt = aSeqSet->elt;

		for (j = 0; j < aSeqSet->noOfElt; j++)
		{
			returnValue += elt[j]->noOfElt*4;
		}
	}

	return returnValue;
}

int stat_calculateUpperHashSize(upperHash *aUpperHash)
{
	int returnValue;
	int upper_noOfSlot;

	int i;

	lowerHash *aLowerHash;

	returnValue = 0;
	upper_noOfSlot = aUpperHash->noOfSlot;

	for (i = 0; i < upper_noOfSlot; i++)
	{
		aLowerHash =  aUpperHash->slot[i];

		returnValue += stat_calculateLowerHashSize(aLowerHash);

	}

	return returnValue;
}

void stat_print(FILE *filePtr, statistics *aStat)
{

	fprintf(filePtr, "%d\n", aStat->noOfRestrictedQueries);
	fprintf(filePtr, "%d\n", aStat->totalNoOfQueries);
	fprintf(filePtr, "%.10f\n", aStat->percentOfRestrictedQueries);
	fprintf(filePtr, "%.10f\n", aStat->totalSize_PCSS);
	fprintf(filePtr, "%.10f\n", aStat->avgSize_PCSS);
	fprintf(filePtr, "%d\n", aStat->size_competitiveService);
	fprintf(filePtr, "%d\n", aStat->totalQueryLength);
	fprintf(filePtr, "%.10f\n", aStat->avgQueryLength);

}
